"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@lightweightform/core");
var mobx_angular_1 = require("mobx-angular");
var create_field_component_1 = require("../create-field-component");
var DATE_SEPARATOR = ' - ';
var DateRangeComponent = /** @class */ (function (_super) {
    __extends(DateRangeComponent, _super);
    function DateRangeComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DateRangeComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.bsConfig = {
            containerClass: 'theme-default',
            rangeInputFormat: 'YYYY-MM-DD',
        };
    };
    Object.defineProperty(DateRangeComponent.prototype, "valueAsString", {
        get: function () {
            return this.value === null
                ? null
                : this.value[1] === null
                    ? this.value[0]
                    : this.value.join(DATE_SEPARATOR);
        },
        enumerable: true,
        configurable: true
    });
    DateRangeComponent.prototype.onDateRangePickerChange = function (dateTuple) {
        var _this = this;
        this.value = dateTuple.map(function (date) { return _this.toDateString(date); });
    };
    DateRangeComponent.prototype.onInput = function (event) {
        var input = event.target.value;
        if (input === '') {
            this.value = null;
        }
        else {
            var _a = input.split(DATE_SEPARATOR), dateStart = _a[0], _b = _a[1], dateEnd = _b === void 0 ? null : _b;
            this.value = [dateStart, dateEnd];
        }
    };
    __decorate([
        mobx_angular_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], DateRangeComponent.prototype, "valueAsString", null);
    DateRangeComponent = __decorate([
        core_1.Component(__assign({}, core_2.dateRangeDecorator, { templateUrl: './date-range.component.html' }))
    ], DateRangeComponent);
    return DateRangeComponent;
}(create_field_component_1.createFieldComponent(core_2.DateRangeController)));
exports.DateRangeComponent = DateRangeComponent;
//# sourceMappingURL=date-range.component.js.map