"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@lightweightform/core");
var table_component_1 = require("../table.component");
var table_column_index_directive_1 = require("./table-column-index.directive");
var table_column_directive_1 = require("./table-column.directive");
var TableHeaderComponent = /** @class */ (function (_super) {
    __extends(TableHeaderComponent, _super);
    function TableHeaderComponent(hostElement, parentTable) {
        var _this = _super.call(this) || this;
        _this.hostElement = hostElement;
        _this.parentTable = parentTable;
        _this.bsClass = 'thead-light';
        return _this;
    }
    TableHeaderComponent.prototype.ngOnInit = function () {
        this.setHeaderHeight();
    };
    Object.defineProperty(TableHeaderComponent.prototype, "childrenColumns", {
        // See: https://github.com/angular/angular/issues/10098
        get: function () {
            var _this = this;
            return (this.indexColumn ? [this.indexColumn] : []).concat(this._childrenColumns.filter(function (column) { return column !== _this; }));
        },
        enumerable: true,
        configurable: true
    });
    TableHeaderComponent.prototype.isIndexColumn = function (column) {
        return column instanceof table_column_index_directive_1.TableColumnIndexDirective;
    };
    // Set the header height on the parent table as soon as it is known
    TableHeaderComponent.prototype.setHeaderHeight = function () {
        var _this = this;
        var height = this.hostElement.nativeElement.offsetHeight;
        if (height > 0) {
            this.parentTable.setHeaderHeight(height + 2);
        }
        else {
            requestAnimationFrame(function () { return _this.setHeaderHeight(); });
        }
    };
    __decorate([
        core_1.HostBinding('class'),
        __metadata("design:type", Object)
    ], TableHeaderComponent.prototype, "bsClass", void 0);
    __decorate([
        core_1.ContentChild(table_column_index_directive_1.TableColumnIndexDirective),
        __metadata("design:type", table_column_index_directive_1.TableColumnIndexDirective)
    ], TableHeaderComponent.prototype, "indexColumn", void 0);
    __decorate([
        core_1.ContentChildren(table_column_directive_1.TableColumnDirective),
        __metadata("design:type", core_1.QueryList)
    ], TableHeaderComponent.prototype, "_childrenColumns", void 0);
    TableHeaderComponent = __decorate([
        core_1.Component(__assign({}, core_2.tableHeaderDecorator, { templateUrl: './table-header.component.html' })),
        __param(0, core_1.Inject(core_1.ElementRef)),
        __param(1, core_1.Inject(table_component_1.TableComponent)),
        __metadata("design:paramtypes", [Object, Object])
    ], TableHeaderComponent);
    return TableHeaderComponent;
}(core_2.TableHeaderController));
exports.TableHeaderComponent = TableHeaderComponent;
//# sourceMappingURL=table-header.component.js.map