"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@lightweightform/core");
var mobx_1 = require("mobx");
var mobx_angular_1 = require("mobx-angular");
var create_field_component_1 = require("../create-field-component");
var TableComponent = /** @class */ (function (_super) {
    __extends(TableComponent, _super);
    function TableComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.headerHeight = 0;
        return _this;
    }
    TableComponent_1 = TableComponent;
    TableComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        // Refresh the virtual scroll component whenever the parent form becomes
        // active (sets the scroll height to the previous value)
        this.disposeOnActive = mobx_1.observe(this.parentRecordController, 'isActive', function (change) {
            if (change.newValue) {
                _this.virtualScroll.refresh();
            }
        });
    };
    TableComponent.prototype.ngAfterViewInit = function () {
        _super.prototype.ngAfterViewInit.call(this);
        // Sync header's scrollLeft with the content's scrollLeft
        var visibleHeaderElem = this.visibleHeader.nativeElement;
        var scrollableElem = this.scrollable.nativeElement;
        this.disposeScroll = this.injector
            .get(core_1.Renderer2)
            .listen(scrollableElem, 'scroll', function () { return (visibleHeaderElem.scrollLeft = scrollableElem.scrollLeft); });
    };
    TableComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        if (this.disposeOnActive) {
            this.disposeOnActive();
        }
        if (this.disposeScroll) {
            this.disposeScroll();
        }
    };
    TableComponent.prototype.setHeaderHeight = function (height) {
        this.headerHeight = height;
    };
    TableComponent.prototype.toggleAllRowsSelectedStatus = function () {
        this.setAllRowsSelectedStatus(!this.allRowsSelected);
    };
    TableComponent.prototype.pushRow = function () {
        _super.prototype.pushRow.call(this);
        this.virtualScroll.scrollTo(this.value.length);
    };
    __decorate([
        core_1.ContentChild('lfTableHeaderTemplate'),
        __metadata("design:type", core_1.TemplateRef)
    ], TableComponent.prototype, "headerTemplate", void 0);
    __decorate([
        core_1.ContentChild('lfTableRowTemplate'),
        __metadata("design:type", core_1.TemplateRef)
    ], TableComponent.prototype, "rowTemplate", void 0);
    __decorate([
        core_1.ViewChild('visibleHeader'),
        __metadata("design:type", core_1.ElementRef)
    ], TableComponent.prototype, "visibleHeader", void 0);
    __decorate([
        core_1.ViewChild('scrollable'),
        __metadata("design:type", core_1.ElementRef)
    ], TableComponent.prototype, "scrollable", void 0);
    __decorate([
        core_1.ViewChild(core_2.VirtualScrollComponent),
        __metadata("design:type", core_2.VirtualScrollComponent)
    ], TableComponent.prototype, "virtualScroll", void 0);
    __decorate([
        mobx_angular_1.observable,
        __metadata("design:type", Number)
    ], TableComponent.prototype, "headerHeight", void 0);
    TableComponent = TableComponent_1 = __decorate([
        core_1.Component(__assign({}, core_2.tableDecorator(TableComponent_1), { templateUrl: './table.component.html' }))
    ], TableComponent);
    return TableComponent;
    var TableComponent_1;
}(create_field_component_1.createFieldComponent(core_2.TableController)));
exports.TableComponent = TableComponent;
//# sourceMappingURL=table.component.js.map