"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@lightweightform/core");
var mobx_angular_1 = require("mobx-angular");
var TreeEntryComponent = /** @class */ (function () {
    function TreeEntryComponent(routerService) {
        this.routerService = routerService;
    }
    Object.defineProperty(TreeEntryComponent.prototype, "formRoutes", {
        // Filter all routes to only get `form` ones
        get: function () {
            var _this = this;
            return this.routes === null
                ? []
                : Object.keys(this.routes).reduce(function (routes, name) {
                    var route = _this.routes[name];
                    if (route.type === 'form') {
                        routes.push(route);
                    }
                    return routes;
                }, []);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreeEntryComponent.prototype, "optionalForms", {
        // filter all optional forms to only get forms that do not exists
        // on the parent value
        get: function () {
            var _this = this;
            return this.routes === null
                ? []
                : Object.keys(this.routes).reduce(function (routes, name) {
                    var route = _this.routes[name];
                    if (route.type === 'form' && _this.valueOf(route) === null) {
                        routes.push(route);
                    }
                    return routes;
                }, []);
        },
        enumerable: true,
        configurable: true
    });
    TreeEntryComponent.prototype.navigateTo = function (evt, formRoute) {
        evt.preventDefault();
        this.routerService.navigateTo(this.getURI(formRoute));
    };
    TreeEntryComponent.prototype.addForm = function (formRoute) {
        formRoute.value.initialize();
        this.routerService.navigateTo(this.getURI(formRoute));
    };
    TreeEntryComponent.prototype.getURI = function (formRoute) {
        return "" + this.parentURI + encodeURIComponent(formRoute.name) + "/";
    };
    TreeEntryComponent.prototype.valueOf = function (formRoute) {
        return this.value === null ? null : this.value[formRoute.name];
    };
    TreeEntryComponent.prototype.showForm = function (formRoute) {
        return this.value === null ? false : this.value[formRoute.name] !== null;
    };
    TreeEntryComponent.prototype.isActive = function (formRoute) {
        return this.routerService.isActive(this.getURI(formRoute));
    };
    TreeEntryComponent.prototype.showSubForms = function (formRoute, formRoutes) {
        return (this.hasSubForms(formRoutes) &&
            (this.isActive(formRoute) || this.hasActiveSubForms(formRoute)));
    };
    TreeEntryComponent.prototype.hasSubForms = function (formRoutes) {
        return (Object.keys(formRoutes).filter(function (routeProp) {
            return formRoutes[routeProp].type === 'form';
        }).length > 0);
    };
    TreeEntryComponent.prototype.hasActiveSubForms = function (formRoute) {
        return this.routerService.hasActiveChild(this.getURI(formRoute));
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], TreeEntryComponent.prototype, "parentURI", void 0);
    __decorate([
        mobx_angular_1.observable,
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeEntryComponent.prototype, "routes", void 0);
    __decorate([
        mobx_angular_1.observable,
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeEntryComponent.prototype, "value", void 0);
    __decorate([
        mobx_angular_1.computed,
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [])
    ], TreeEntryComponent.prototype, "formRoutes", null);
    __decorate([
        mobx_angular_1.computed,
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [])
    ], TreeEntryComponent.prototype, "optionalForms", null);
    __decorate([
        mobx_angular_1.action,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", void 0)
    ], TreeEntryComponent.prototype, "navigateTo", null);
    __decorate([
        mobx_angular_1.action,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], TreeEntryComponent.prototype, "addForm", null);
    TreeEntryComponent = __decorate([
        core_1.Component({
            selector: 'bs-tree-entry',
            changeDetection: core_1.ChangeDetectionStrategy.OnPush,
            templateUrl: './tree-entry.component.html',
        }),
        __metadata("design:paramtypes", [core_2.RouterService])
    ], TreeEntryComponent);
    return TreeEntryComponent;
}());
exports.TreeEntryComponent = TreeEntryComponent;
//# sourceMappingURL=tree-entry.component.js.map